/*
**	$Id: geometry.h 937 2006-08-10 09:37:18Z gromeck $
**
**	Copyright (c) 2004 by Christian Lorenz
**
**	handle geometries
*/

#ifndef __GIP_GEOMETRY_H__
#define __GIP_GEOMETRY_H__ 1

#define GIP_GEOMETRY_PERCENT_100		"100%"
#define GIP_GEOMETRY_PERCENT_90			"90%"

/*
**	init & shutdown the API
*/
int GIP_geometry_init(void);
int GIP_geometry_exit(void);

/*
**	parse a geometry string and return the dimensions
*/
int GIP_geometry_parse(const char *geo,
		int image_width,int image_height,
		int frame_width,int frame_height,
		int *x,int *y,int *w,int *h);

/*
**	process the geometry
*/
int GIP_geometry_process(const char *from_geo,const char *to_geo,
		int image_width,int image_height,
		int frame_width,int frame_height,
		int step,int steps,
		int *x,int *y,int *w,int *h);

#endif

/**/
