/*
**	$Id: gip.c 952 2007-02-13 13:21:43Z gromeck $
**
**	Copyright (c) 2004 by Christian Lorenz
**
**	GIP API
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <config.h>
#include "gip.h"

/*
**	should we run in quick mode
*/
int _gip_quick = 0;

/*
**	init the API
*/
int GIP_init(int quick,const char *title,const char *logfile)
{
	int rc = 1;

	rc = rc && GIP_error_init(title,logfile);
	rc = rc && GIP_progress_init();
	rc = rc && GIP_color_init();
	rc = rc && GIP_geometry_init();
	rc = rc && GIP_times_init();
	rc = rc && GIP_transition_init();
	rc = rc && GIP_image_init();
	rc = rc && GIP_audio_init();
	rc = rc && GIP_index_init();

	_gip_quick = quick;

	return rc;
}

/*
**	shutdown the API
*/
int GIP_exit(void)
{
	int rc = 1;

	rc = rc && GIP_index_exit();
	rc = rc && GIP_audio_exit();
	rc = rc && GIP_image_exit();
	rc = rc && GIP_transition_exit();
	rc = rc && GIP_times_exit();
	rc = rc && GIP_geometry_exit();
	rc = rc && GIP_color_exit();
	rc = rc && GIP_progress_exit();
	rc = rc && GIP_error_exit();

	return rc;
}

/*
**	return the low-level library
*/
const char *GIP_version(char *version)
{
#if HAVE_LIBMAGICK
	unsigned long version_number;
#endif

#if HAVE_LIBMAGICK
	strcpy(version,GetMagickVersion(&version_number));
#endif
#if HAVE_LIBIL
	sprintf(version,"Developer's Image Library (DevIL) V%d",IL_VERSION);
#endif
	return version;
}/**/
